/*
 * siusb.h
 *
 * SI-1280 USB Camera Driver
 */

#ifndef SIUSB_H /* Prevent multiple includes */
#define SIUSB_H

#include <linux/videodev.h>

/* Clock frequencies
 */
#define SIUSB_CLK_20MHZ         (0x30|(0x68<<8)|(0x86<<16))
#define SIUSB_CLK_25MHZ         (0x30|(0xB6<<8)|(0x89<<16))
#define SIUSB_CLK_30MHZ         (0x37|(0xCB<<8)|(0x8F<<16))
#define SIUSB_CLK_35MHZ         (0x35|(0xD4<<8)|(0x0B<<16))
#define SIUSB_CLK_40MHZ         (0x30|(0x68<<8)|(0x82<<16))
#define SIUSB_CLK_45MHZ         (0x35|(0xE7<<8)|(0x09<<16))
#define SIUSB_CLK_50MHZ         (0x34|(0xB6<<8)|(0x89<<16))
#define SIUSB_CLK_55MHZ         (0x34|(0xB6<<8)|(0x88<<16))
#define SIUSB_CLK_60MHZ         (0x36|(0xCB<<8)|(0x8F<<16))

/* Gain values
 */
#define SIUSB_GAIN_MIN          0x00
#define SIUSB_GAIN_MAX          0x67
#define SIUSB_GAIN_UNITY        0x08

/* ioctls
 */

#define SIUSB_IOC_GET_CLOCK         _IOR('v', BASE_VIDIOCPRIVATE+ 0, unsigned)
#define SIUSB_IOC_SET_CLOCK         _IOW('v', BASE_VIDIOCPRIVATE+ 1, unsigned)

#define SIUSB_IOC_GET_EXPOSURE      _IOR('v', BASE_VIDIOCPRIVATE+ 2, unsigned)
#define SIUSB_IOC_SET_EXPOSURE      _IOW('v', BASE_VIDIOCPRIVATE+ 3, unsigned)

#define SIUSB_IOC_GET_GAIN          _IOR('v', BASE_VIDIOCPRIVATE+ 4, unsigned)
#define SIUSB_IOC_SET_GAIN          _IOW('v', BASE_VIDIOCPRIVATE+ 5, unsigned)

#endif /* SIUSB_H */
